# This file is a template, and might need editing before it works on your project.
# To contribute improvements to CI/CD templates, please follow the Development guide at:
# https://docs.gitlab.com/ee/development/cicd/templates.html
# This specific template is located at:
# https://gitlab.com/gitlab-org/gitlab/-/blob/master/lib/gitlab/ci/templates/Getting-Started.gitlab-ci.yml

# This is a sample GitLab CI/CD configuration file that should run without any modifications.
# It demonstrates a basic 3 stage CI/CD pipeline. Instead of real tests or scripts,
# it uses echo commands to simulate the pipeline execution.
#
# A pipeline is composed of independent jobs that run scripts, grouped into stages.
# Stages run in sequential order, but jobs within stages run in parallel.
#
# For more information, see: https://docs.gitlab.com/ee/ci/yaml/README.html#stages

variables:
  PUBLIC_URL: $CI_PAGES_URL
  HOMEPAGE: $CI_PAGES_URL

stages:          # List of stages for jobs, and their order of execution
  - build
  - deploy-pages

build-job:       # This job runs in the build stage, which runs first.
  stage: build
  image: node:lts-alpine
  script:
    - echo $PUBLIC_URL
    - echo "Compiling the code..."
    - npm ci
    - npm run build
    - mv public public-orig
    - ls -la dist
    - mv dist public
    - ls -la public
    - echo "Compile complete."
  artifacts:
    paths:
      - public # artifact path must be /public for GitLab Pages to pick it up

pages: # the job must be named pages
  image: node:lts-alpine
  stage: deploy-pages
  script:
    # optionally, you can activate gzip support wih the following line:
    - find public -type f -regex '.*\.\(htm\|html\|txt\|text\|js\|css\)$' -exec gzip -f -k {} \;
  artifacts:
    paths:
      - public # artifact path must be /public for GitLab Pages to pick it up
